<?php
require_once 'wpwm-autofetch.php';
require_once 'wpwm-manage-links.php';

/* docs page */
function wpwm_docs() {
	$docs_file = plugin_dir_path(__FILE__);
	echo file_get_contents($docs_file . '../documentation.html');
}

/* settings page */
function wpwm_settings() {
	echo '<div class="wrap wpwm-wrapper">';
	echo '<h2>WP Watch Movies - Items Per Page / Row</h2>';

	if(isset($_POST['sb_wpwm'])) {
		update_option('wpwm_movies_per_page', abs(intval($_POST['wpwm_movies_per_page'])));
		update_option('wpwm_movies_per_row', abs(intval($_POST['wpwm_movies_per_row'])));
		update_option('wpwm_homepage_items', abs(intval($_POST['wpwm_homepage_items'])));

		echo '<div class="updated below-h2">Updated</div>';

	}

	$wpwm_movies_per_page = get_option('wpwm_movies_per_page', 10); 
	$wpwm_movies_per_row = get_option('wpwm_movies_per_row', 5); 
	$wpwm_homepage_items = get_option('wpwm_homepage_items', 5);
	?>

	<form method="POST">
	<label>Items Per Page: </label>
		<input type="number" value="<?=$wpwm_movies_per_page ?>" name="wpwm_movies_per_page" />	

	<br />

	<label>Items Per Row: </label>
		<input type="number" value="<?=$wpwm_movies_per_row ?>" name="wpwm_movies_per_row" />
	
	<br />

	<label>Items Per Homepage: </label>
		<input type="number" value="<?=$wpwm_homepage_items ?>" name="wpwm_homepage_items" />
	
	<br />

	<input type="submit" name="sb_wpwm" value="Save" class="button-primary" />
	</form>
	<?php
	echo '</div>';
}

/* create admin menu */
function wpwm_admin_menu() {
	add_submenu_page( 'edit.php?post_type=watch', 'WP Watch Movies Autofetch', 'Autofetch Movie Info', 'manage_options', 'wpwm-autofetch', 'wpwm_auto_fetch' );
	add_submenu_page( 'edit.php?post_type=watch', 'WP Watch Movies Links', 'Movie Links', 'manage_options', 'wpwm-links', 'wpwm_manage_links' );
    add_submenu_page( 'edit.php?post_type=watch', 'WP Watch Movies Settings', 'Items Per Page/Row', 'manage_options', 'wpwm-settings', 'wpwm_settings' );
    add_submenu_page( 'edit.php?post_type=watch', 'WP Watch Movies Docs', 'Doccumentation', 'manage_options', 'wpwm-docs', 'wpwm_docs' );
}

add_action('admin_menu', 'wpwm_admin_menu');